var northPos = 735;
var qthMarker;
var currPosMarker;
var destMarker;
function init()
{
	var qthPos = new google.maps.LatLng( 47.64123, 18.30252 );
	var myOptions = {
		zoom: 8,
		center: qthPos,
		mapTypeId: google.maps.MapTypeId.HYBRID
	};
	var map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);

	var myOptions = {
		position: qthPos,
		map: map,
		title: "HA2NON's QTH",
		icon: 'embassy.png',
		zIndex: 150
	};
    qthMarker = new google.maps.Marker( myOptions );

	var myOptions = {
		position: new google.maps.LatLng( 47.64123, 18.0000 ),
		map: map,
		title: "Current position",
		icon: 'sciencecenter.png',
		zIndex: 50
	};
    currPosMarker = new google.maps.Marker( myOptions );

	var myOptions = {
		position: currPosMarker.getPosition(),
		map: map,
		title: "Destination",
		draggable: true,
		zIndex: 100
	};
    destMarker = new google.maps.Marker( myOptions );

	google.maps.event.addListener( destMarker, 'dragend', function(event) {
		calcDestDegrees();
		calcDestDistance();
		$('status-destpos-value').innerHTML = calcPosFromDegrees( parseInt( $('status-destdeg-value').innerHTML ) );
		autoRotateCheck();
	});

	$('status-log').value = '';
	$('status-input').focus();

    new Ajax.Request( 'ajax.js.php', {
		method: 'post',
		parameters: {
			sendmessage: "o\rs",
			init: '1'
		}
    } );
}

function autoRotateCheck()
{
	if( $('controls-autorotate').checked && $('status-destpos-value').innerHTML != $('status-currpos-value').innerHTML && $('status-destpos-value').innerHTML != 'N/A' )
		sendMessage( 'g' + $('status-destpos-value').innerHTML );
	else
	{
		if( $('status-status').innerHTML != 'idle' )
			sendMessage( 'r0' );
	}
}

function reposCurrPosMarker( angle )
{
	var distance = Math.sqrt( Math.pow( qthMarker.getPosition().lng() - destMarker.getPosition().lng(), 2 ) + Math.pow( qthMarker.getPosition().lat() - destMarker.getPosition().lat(), 2 ) );
	x = Math.sin( angle * (Math.PI / 180) ) * distance + qthMarker.getPosition().lng();
	y = Math.cos( angle * (Math.PI / 180) ) * distance + qthMarker.getPosition().lat();
	currPosMarker.setPosition( new google.maps.LatLng( y, x ) );

	calcDestDegrees();
	calcDestDistance();
}

function calcDestDegrees()
{
	var angle = ( Math.atan2( qthMarker.getPosition().lng() - destMarker.getPosition().lng(), qthMarker.getPosition().lat() - destMarker.getPosition().lat() ) / (2*Math.PI) ) * 360 + 180;
	if( angle == 360 )
		angle = 0;
	$('status-destdeg-value').innerHTML = Math.round( angle );
}

function calcDestDistance()
{
	$('status-destdistance-value').innerHTML = distHaversine( destMarker.getPosition(), qthMarker.getPosition() );
}

function calcDegreesFromPos( pos )
{
	return Math.round( (pos / northPos) * 360 );
}

function calcPosFromDegrees( deg )
{
	return Math.round( (deg / 360) * northPos );
}

function sendMessage( msg )
{
    new Ajax.Request( 'ajax.js.php', {
		method: 'post',
		parameters: {
			sendmessage: msg
		}
    } );
}

var refreshInterval = 0;
var refreshTimerRunning = 0;
function refresh()
{
    new Ajax.Request( 'ajax.js.php', {
		method: 'post',
		parameters: {
			sendmessage: 's'
		}
    } );
}

function gotoBank( num )
{
	sendMessage( 'g' + $('memory-button-' + num).value.split(' ')[1] );
}

function eraseBank( num )
{
	if( confirm( 'Really erase bank #' + num + '?' ) )
		sendMessage( "e" + num + "\ro" );
}

function writeBank()
{
	var name = prompt( 'Bank name:' );
	if( name != '' )
		sendMessage( 'w' + name + "\ro" );
}
